Object subclass: #SpendingHistory
	instanceVariableNames: 'cashOnHand expenditures '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spending'!


!SpendingHistory methodsFor: 'printing'!

printOn: aStream
	"print a suitable representation of myself on aStream"

	super printOn: aStream.
	aStream space.
	aStream nextPutAll: 'balance: '.
	cashOnHand printOn: aStream.
	expenditures keysAndValuesDo: [:reason :amount |
		aStream cr.
		reason printOn: aStream.
		aStream tab.
		amount printOn: aStream]! !

!SpendingHistory methodsFor: 'transactions'!

spend: anAmount on: reason
	"Spend anAmount on reason, reducing the available cashOnHand"

	expenditures 
		at: reason 
		put: (self totalSpentOn: reason) + anAmount.
	cashOnHand := cashOnHand - anAmount.! !

!SpendingHistory methodsFor: 'inquiries'!

totalSpentOn: reason
	"return the amount spent on reason. Answer
	0 if reason is not used for expenditures"

	(expenditures includesKey: reason) 
		ifTrue: [^expenditures at: reason]
		ifFalse: [^0]! !

!SpendingHistory methodsFor: 'private'!

setInitialBalance: anAmount
	"Initialize the instance variables;
	cashOnHand is set to amount"

	cashOnHand := anAmount.
	expenditures := Dictionary new.! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SpendingHistory class
	instanceVariableNames: ''!


!SpendingHistory class methodsFor: 'instance creation'!

initialBalance: anAmount
	^super new setInitialBalance: anAmount! !

