'From VisualWorks(R) Release 2.0 of 4 August 1994 on 4 April 1996 at 11:31:54 am'!

SpendingHistory subclass: #FinancialHistory
	instanceVariableNames: 'incomes '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Financial Tools'!


!FinancialHistory methodsFor: 'private'!

setInitialBalance: anAmount
	super setInitialBalance: anAmount.
	incomes := Dictionary new.! !

!FinancialHistory methodsFor: 'inquiries'!

totalReceivedFor: reason
	"return the amount received from reason. Answer
	0 if reason is not used for incomes"

	^(incomes includesKey: reason) 
		ifTrue:[incomes at: reason]
		ifFalse: [0]! !

!FinancialHistory methodsFor: 'transactions'!

receive: anAmount for: reason
	"Receive anAmount for a reason and increase the cashOnHand"

	incomes 
		at: reason 
		put: (self totalReceivedFor: reason) + anAmount.
	cashOnHand := cashOnHand + anAmount.! !

!FinancialHistory methodsFor: 'printing'!

printOn: aStream
	"print a suitable representation of myself on aStream"

	super printOn: aStream.
	aStream space.
	incomes keysAndValuesDo: [:reason :amount |
		aStream cr.
		reason printOn: aStream.
		aStream tab.
		amount printOn: aStream]! !
