Object subclass: #BinaryTree
	instanceVariableNames: 'leftNode rightNode value tally '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ex15.2'!
BinaryTree comment:
'This class is the answer to exercise 15.2. It represents the node in a binary tree.

Instance Variables:
leftNode		<BinaryTree | nil> the root of my left tree
rightNode	<BinaryTree | nil> the root of my right tree
value		<Object> the element at this node. (Must repsond to #> and #<)
tally			<Integer> number of occurrences of value'!


!BinaryTree methodsFor: 'adding'!

add: aValue 
	"Only add aValue if it is the same class as my value"

	aValue class = value class ifFalse: [^self].
	aValue = value ifTrue:[tally := tally + 1].
	aValue < value ifTrue: [self addLeft: aValue].
	aValue > value ifTrue: [self addRight: aValue].
	^aValue! !

!BinaryTree methodsFor: 'accessing'!

elements
	^self asOrderedCollection! !

!BinaryTree methodsFor: 'private'!

addLeft: aValue 
	leftNode isNil
		ifTrue: [leftNode := self class value: aValue]
		ifFalse: [leftNode add: aValue]!

addRight: aValue 
	rightNode isNil
		ifTrue: [rightNode := self class value: aValue]
		ifFalse: [rightNode add: aValue]!

asOrderedCollection
	| collection |
	collection := OrderedCollection new.
	self insertInto: collection.
	^collection!

insertInto: aCollection
	leftNode notNil ifTrue:[leftNode insertInto: aCollection].
	tally timesRepeat: [aCollection add: value].
	rightNode notNil ifTrue:[rightNode insertInto: aCollection]!

setValue: aValue
	value := aValue.
	tally := 1.! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

BinaryTree class
	instanceVariableNames: ''!


!BinaryTree class methodsFor: 'instance creation'!

value: aValue
	^self new setValue: aValue! !

!BinaryTree class methodsFor: 'examples'!

example
	"Be able to add to and return the elements from a BinaryTree"
	"BinaryTree example"

	| tree |
	tree := self value: 6. "Create a new tree whose object is 6"
	#(12 34 #e 67 $e 89 'e' 10 3 6) do: [:i | 
		tree add: i].	"add objects to the tree"
	^tree elements 	"return objects in ascending order"! !

