ReadStream subclass: #CircularStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ex18.5'!
CircularStream comment:
'This class is the answer to exercise 18.5. It represents a stream which has no end!!.'!


!CircularStream methodsFor: 'accessing'!

next
	"Answer the next object in the Stream represented by the receiver.
	Fail if the collection of this stream is not an Array or a String. Fail if
	the stream is positioned at its end, or if the position is out of bounds in
	the collection."

	<primitive: 65>
	position >= readLimit
		ifTrue: [position := 0. ^self next]
		ifFalse: [^collection at: (position := position + 1)]! !

!CircularStream methodsFor: 'testing'!

atEnd
	^false! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

CircularStream class
	instanceVariableNames: ''!


!CircularStream class methodsFor: 'example'!

example
	"Create an instance of me on an interval. Print each element of the stream 
	until the end is reached -- which is never!! (Hit <control>-c to stop ;-)"
	"CircularStream example"

	| stream |
	stream := self on: (10 to: 1 by: -1).
	[stream atEnd]
		whileFalse: [Transcript show: stream next printString; cr]! !

