Object subclass: #Counter
	instanceVariableNames: 'value '
	classVariableNames: 'Process1 Process2 '
	poolDictionaries: ''
	category: 'Ex25.11'!
Counter comment:
'This class is the answer to exercise 25.11. It demonstrates the use of two processes.

Instance variables:
value	<Integer>	a simple count

Class Variables:
Process1	<Process>	used in examples.
Process2	<Process> 	used in examples.

See class examples'!


!Counter methodsFor: 'initialize-release'!

initialize
	value := 0! !

!Counter methodsFor: 'read/write'!

increment
	value := value + 1!

value
	^value!

value: anInteger
	value := anInteger! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Counter class
	instanceVariableNames: ''!


!Counter class methodsFor: 'instance creation'!

new
	^super new initialize! !

!Counter class methodsFor: 'example'!

example
	"Counter example"
	"Note that I have made the two processes class variables -- this is instead of 
	using globals as suggested in the text. 
	To start the processes use 
	'Counter startProcesses' 
	, and to terminate use 
	'Counter terminateProcesses'"
	"What you should see in the Transcript is a sequence of numbers, ideally it 
	should be a sequence of 9's , but if you are using the image for other activities, 
	like writing code, or moving window, you'll get the occassional numbers 
	greater than 9"
	"This behaviour occurs because the two processes are not synchronised!!"! !

!Counter class methodsFor: 'processes'!

createProcesses
	"Counter createProcesses"

	| counter |
	counter := self new.
	Process1 := 
			[| delay |
			delay := Delay forMilliseconds: 40.
			[counter increment.
			delay wait] repeat] newProcess.
	Process2 := 
			[| delay |
			delay := Delay forMilliseconds: 40.
			[| currentValue |
			currentValue := counter value.
			currentValue >= 9
				ifTrue: 
					[Transcript cr; show: currentValue printString.
					counter value: 0].
			delay wait] repeat] newProcess.
	Process2 priority: Processor userBackgroundPriority!

startProcesses
	"Counter startProcesses"
	Process1 resume.
	Process2 resume.!

terminateProcesses
	"Counter terminateProcesses"
	Process1 terminate.
	Process2 terminate.! !

!Counter class methodsFor: 'class initialization'!

initialize
	"Counter initialize"
	self createProcesses! !
Counter initialize!


