'From VisualWorks(R) Release 2.0 of 4 August 1994 on 2 December 1996 at 9:26:15 pm'!

VisualPart subclass: #ClockView
	instanceVariableNames: 'clockProcess running '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'View examples'!
ClockView comment:
'I represent a view for a clock. Simply I display the current time.

Instance variables:
clockProcess	<Process>	constantly invalidate myself (with a delay)
running			<Boolean>	to keep track of whether the process is running'!


!ClockView methodsFor: 'bounds accessing'!

preferredBounds
	"answer my preferred bounds (actually the bounds of the text I'm going to display)"

	^Time now printString asComposedText preferredBounds! !

!ClockView methodsFor: 'displaying'!

displayOn: aGraphicsContext 
	"display the time"

	Time now printString asComposedText displayOn: aGraphicsContext! !

!ClockView methodsFor: 'initialize-release'!

initialize
	"initiate the clock process"

	| delay |
	super initialize.
	running := false.
	delay := Delay forSeconds: 1.
	clockProcess := [
			[self invalidate.
"Causes the window view to re-display"
			delay wait] repeat] newProcess.
	self start!

release
	"terminate the process"

	self stop.
	clockProcess terminate.
	super release! !

!ClockView methodsFor: 'control'!

start
	"Start the clock"

	running
		ifFalse: 
			[clockProcess resume.
			running := true]!

stop
	"Stop the clock"

	running
		ifTrue: 
			[clockProcess suspend.
			running := false]! !
